#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
		case OP_SysOp:
		case OP_SuperModerator:
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p, "Ext: !jperiodic !jgreet !victory !bantime");
				sendPrivate(p, "Ext: !antiwarp !warnmode !radius !delay");
				sendPrivate(p, "Ext: !teamkill !safekill !skradius !warn !grace");
				sendPrivate(p, "Ext: !fperiodic !eventeams !setteams !saveconfig");
			}
			break;
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
				sendPrivate(p, "Ext: !jperiodic !jgreet !victory !bantime");
				sendPrivate(p, "Ext: !antiwarp !warnmode !radius !delay");
				sendPrivate(p, "Ext: !teamkill !safekill !skradius !warn !grace");
				sendPrivate(p, "Ext: !fperiodic !eventeams !setteams !saveconfig");
			}
			else if (c->checkParam("warnmode"))
			{
				sendPrivate(p, "!warnmode [0/1/2] (0=do not warn 1=warn the first time only 2=warn every time)");
			}
			else if (c->checkParam("delay"))
			{
				sendPrivate(p, "!delay [milliseconds] (awarp only: set delay before removing antiwarp)");
			}
			else if (c->checkParam("radius"))
			{
				sendPrivate(p, "!radius [tiles] (set radius from center where checking happens)");
			}
			else if (c->checkParam("antiwarp"))
			{
				sendPrivate(p, "!antiwarp [on/off] (turn antiwarp checking on/off)");
			}
			else if (c->checkParam("jperiodic"))
			{
				sendPrivate(p, "!jperiodic [#seconds/on/off] (announce jackpot changes periodically?)");
			}
			else if (c->checkParam("jgreet"))
			{
				sendPrivate(p, "!jgreet [on/off] (greet players with the jackpot?)");
			}
			else if (c->checkParam("victory"))
			{
				sendPrivate(p, "!victory [on/off] (spam arena with winners' info?)");
			}
			else if (c->checkParam("teamkill"))
			{
				sendPrivate(p, "!teamkill [on/off] (turn teamkill checker on/off)");
			}
			else if (c->checkParam("safekill"))
			{
				sendPrivate(p, "!safekill [on/off] (turn safekill checker on/off)");
			}
			else if (c->checkParam("skradius"))
			{
				sendPrivate(p, "!skradius [on/off] (use !radius setting to restrict safekill detection)");
			}
			else if (c->checkParam("warn"))
			{
				sendPrivate(p, "!warn [number] (set number of warnings before kick/banning)");
			}
			else if (c->checkParam("grace"))
			{
				sendPrivate(p, "!grace [minutes] (set number of minutes before a single warning for all players is forgiven)");
			}
			else if (c->checkParam("bantime"))
			{
				sendPrivate(p, "!bantime [minutes] (set number of minutes to kick/ban players)");
			}
			else if (c->checkParam("fperiodic"))
			{
				sendPrivate(p, "!fperiodic [minutes/on/off] (enable, disable, or set number of minutes between each flag coords announcement)");
			}
			else if (c->checkParam("eventeams"))
			{
				sendPrivate(p, "!eventeams [players/on/off] (enable, disable, or set number of players before bot complains about teams being uneven)");
			}
			else if (c->checkParam("setteams"))
			{
				sendPrivate(p, "!setteams [number of teams] (set number of teams the bot should monitor for !eventeams. default is 2: 0 and 1)");
			}
			else if (c->checkParam("saveconfig"))
			{
				sendPrivate(p, "!saveconfig (Saves the current setting of the bot into the .ini file)");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->check("version"))
			{
				sendPrivate(p, "[name:flag.dll] [maker:cat02e@fsu.edu] [build:7 1/2]");
				sendPrivate(p, "File Loading and Saving by 50% Packetloss (FiftyPacketloss@socal.rr.com)");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->check("eventeams"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 2) && (n <= 10))
					{
						unevenplayers = n;
					}
					else
					{
						sendPrivate(p, "Eventeams: Legal values are between 2 and 10 players");
						break;
					}
				}
				else if (c->checkParam("on"))
					checkeventeams = true;
				else if (c->checkParam("off"))
					checkeventeams = false;

				if (checkeventeams)
					sendPrivate(p, "Teams-uneven message is displayed when teams are " + String(unevenplayers) + " players different.");
				else
					sendPrivate(p, "Not checking for uneven teams");
			}
			else if (c->check("setteams"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 2) && (n <= NUM_TEAMS))
					{
						uneventeams = n;
					}
					else
					{
						sendPrivate(p, "Setteams: Legal values are between 2 and 10 teams");
						break;
					}
				}

				sendPrivate(p, "Uneven teams checked for the first " + String(uneventeams) + " teams.");
			}
			else if (c->check("fperiodic"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 1) && (n <= 60))
					{
						flagtime = n;
						countdown[3] = flagtime * 60;
					}
					else
					{
						sendPrivate(p, "Fperiodic: Legal values are between 1 and 60 minutes");
						break;
					}
				}
				else if (c->checkParam("on"))
					spamflags = true;
				else if (c->checkParam("off"))
					spamflags = false;

				if (spamflags)
					sendPrivate(p, "Periodically announcing flag coords every " + String(flagtime) + " minutes.");
				else
					sendPrivate(p, "Not periodically announcing flag coords");
			}
			else if (c->check("warnmode"))
			{	// !warn [0/1/2]
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 0) && (n <= 2))
						warn = n;
					else
					{
						sendPrivate(p, "Warn: Legal values are between 0 and 2");
						break;
					}
				}

				switch (warn)
				{
				case 0:	sendPrivate(p, "Warn mode: No *warnings will be sent to offenders");
						break;
				case 1:	sendPrivate(p, "Warn mode: Only *warning players on the first offense");
						break;
				case 2:	sendPrivate(p, "Warn mode: *warning players on every offense");
				}
			}
			else if (c->check("delay"))
			{	// !delay [seconds]
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 0) && (n <= 5000))
						delay = n;
					else
					{
						sendPrivate(p, "Delay: Legal values are between 0 and 5000 milliseconds");
						break;
					}
				}

				sendPrivate(p, "Delay: " + String(delay));
			}
			else if (c->check("radius"))
			{	// !radius [tiles]
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 0) && (n <= 512))
						radius = n;
					else
					{
						sendPrivate(p, "Radius: Legal values are between 0 and 512");
						break;
					}
				}

				sendPrivate(p, "Radius: " + String(radius));
			}
			else if (c->check("antiwarp"))
			{	// !antiwarp [on/off]
				if (c->checkParam("on"))
				{
					if (!enabled)
						sendPublic("*arena Antiwarp checking resumed");

					enabled = true;
				}
				else if (c->checkParam("off"))
				{
					if (enabled)
						sendPublic("*arena Antiwarp checking disabled");

					enabled = false;
				}

				if (enabled)
					sendPrivate(p, "Checking antiwarp");
				else
					sendPrivate(p, "Not checking antiwarp");
			}
			else if (c->check("jperiodic"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 1) && (n <= 60))
					{
						periodic = n;
						countdown[0] = periodic * 60;
					}
					else
					{
						sendPrivate(p, "Jperiodic: Legal values are between 1 and 60 minutes");
						break;
					}
				}
				else if (c->checkParam("on"))
					jperiodic = true;
				else if (c->checkParam("off"))
					jperiodic = false;

				if (jperiodic)
					sendPrivate(p, "Periodically announcing jackpot every " + String(periodic) + " minutes.");
				else
					sendPrivate(p, "Not periodically announcing jackpot");
			}
			else if (c->check("jgreet"))
			{
				if (c->checkParam("on"))
					jgreet = true;
				else if (c->checkParam("off"))
					jgreet = false;

				if (jgreet)
					sendPrivate(p, "Greeting players with the jackpot");
				else
					sendPrivate(p, "Not greeting players with the jackpot");
			}
			else if (c->check("teamkill"))
			{
				if (c->checkParam("on"))
					teamkill = true;
				else if (c->checkParam("off"))
					teamkill = false;

				if (teamkill)
					sendPrivate(p, "Teamkill detector enabled");
				else
					sendPrivate(p, "Teamkill detector disabled");
			}
			else if (c->check("safekill"))
			{
				if (c->checkParam("on"))
					safekill = true;
				else if (c->checkParam("off"))
					safekill = false;

				if (safekill)
					sendPrivate(p, "safekill detector enabled");
				else
					sendPrivate(p, "safekill detector disabled");
			}
			else if (c->check("skradius"))
			{
				if (c->checkParam("on"))
					skradius = true;
				else if (c->checkParam("off"))
					skradius = false;

				if (skradius)
					sendPrivate(p, "safekill radius in effect");
				else
					sendPrivate(p, "safekill radius not being used");
			}
			else if (c->check("bantime"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 1) && (n <= 14440))
						bantime = n;
					else
					{
						sendPrivate(p, "Bantime: Legal values are between 1 and 14440 minutes");
						break;
					}
				}

				sendPrivate(p, "Kick/banning players for " + String(bantime) + " minutes for teamkilling or safekilling.");
			}
			else if (c->check("warn"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 1) && (n <= 10))
						warnings = n;
					else
					{
						sendPrivate(p, "Warn: Legal values are between 1 and 10 warnings");
						break;
					}
				}

				sendPrivate(p, "Warning players " + String(warnings) + " times before kick/banning for teamkilling or safekilling.");
			}
			else if (c->check("grace"))
			{
				if (isNumeric(c->final))
				{
					int n = getInteger(c->final, 10);
					if ((n >= 1) && (n <= 14440))
					{
						grace = n;
						countdown[2] = grace * 60;
					}
					else
					{
						sendPrivate(p, "Grace: Legal values are between 1 and 14440 minutes");
						break;
					}
				}

				sendPrivate(p, "Every " + String(grace) + " minutes, one warning will be forgiven for teamkilling or safekilling.");
			}
			else if (c->check("victory"))
			{
				if (c->checkParam("on"))
					victory = true;
				else if (c->checkParam("off"))
					victory = false;

				if (victory)
					sendPrivate(p, "Spamming the arena with victorous team");
				else
					sendPrivate(p, "Not spamming the arena with victorous team");
			}
			else if (c->check("saveconfig"))
			{
				WriteIni();
				sendPrivate(p, "Save Complete!");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
